//--redFrik 2014

//TODO: version for Document

RedAsciiAmplitude {
	var syn, osc;
	*new {|in= 0, width= 50|
		^super.new.initRedAsciiAmplitude(in, width);
	}
	initRedAsciiAmplitude {|in, width|
		Server.default.waitForBoot{
			SynthDef(\redAsciiAmplitude, {|in= 0, atk= 0.01, rel= 0.1, lag= 0, fps= 60|
				var src= Mix(InFeedback.ar(in, 2));
				var trk= Amplitude.kr(src, atk, rel).lag(lag);
				SendReply.kr(Impulse.kr(fps), '/redAsciiAmplitude', trk);
			}).add;
			Server.default.sync;
			syn= Synth(\redAsciiAmplitude, [\in, in], Server.default, \addToTail);
			osc= OSCFunc({|msg|
				var amp= msg[3];
				var str= CollStream.on(String(width*2));
				(amp.min(1)*width).asInteger.do{str<<$-};
				str<<$@;
				(amp.max(1)-1*width).asInteger.do{str<<$X};
				str.contents.postln;
			}, '/redAsciiAmplitude');
		};
	}
	stop {
		syn.free;
		osc.free;
	}
	in_ {|bus= 0| syn.set(\in, bus)}
	atk_ {|val= 0.01| syn.set(\atk, val)}
	rel_ {|val= 0.1| syn.set(\rel, val)}
	lag_ {|val= 0| syn.set(\lag, val)}
	fps_ {|val= 60| syn.set(\fps, val)}
}
